﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

using AirplaneWithRadar.PaintObjects;
using AirplaneWithRadar.MovementStrategy;

namespace AirplaneWithRadar.Generics;

internal class AirplanesGenericCollection<T,U>
    where T : PaintAirplane
    where U : IMoveableObject
{
    private readonly int pictWidth;
    private readonly int pictHeight;
    private readonly int placeSizeWidth = 210;
    private readonly int placeSizeHeight = 90;
    private readonly SetGeneric<T> collection;

    public AirplanesGenericCollection(int picWidth, int picHeight)
    {
        int width = picWidth / placeSizeWidth;
        int height = picHeight / placeSizeHeight;
        pictWidth = picWidth;
        pictHeight = picHeight;
        collection = new SetGeneric<T>(width * height);

    }

    public static bool operator +(AirplanesGenericCollection<T, U> collect, T?
obj)
    {
        if (obj == null)
        {
            return false;
        }
        return collect?.collection.Insert(obj) ?? false;
    }
    public static T? operator -(AirplanesGenericCollection<T, U> collect, int
    pos)
    {
        T? obj = collect.collection.Get(pos);
        if (obj != null)
        {
            collect.collection.Remove(pos);
        }
        return obj;
    }


}
