﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace AirplaneWithRadar.Generics;

internal class SetGeneric<T>
    where T : class
{
    private readonly T?[] places;
    public int  Count => places.Length;
    public SetGeneric(int count)
    {
        places = new T?[count];
    }

    public bool Insert(T airplane)
    {
        if (places[0] == null)
        {
            places[0] = airplane;
        }
        else
        {
            for (int i = Count - 1; i < 0; i--)
            {
                places[i] = places[i - 1];
            }
            places[0] = airplane;
        }
        return true;
    }
    public bool Insert(T airplane, int position)
    {
        if (position > Count || position < 0)
        {
            return false;
        }
        // TODO проверка, что элемент массива по этой позиции пустой, если нет, то
        // проверка, что после вставляемого элемента в массиве есть пустой элемент
        // сдвиг всех объектов, находящихся справа от позиции до первого пустого элемента
        // TODO вставка по позиции
        places[position] = airplane;
        return true;
    }
    public bool Remove(int position)
    {
        if (position > Count || position < 0)
        {
            return false;
        }
        places[position] = null;
        return true;
    }
    public T? Get(int position)
    {
        if (position > Count || position < 0)
        {
            return null;
        }
        return places[position];
    }
}
